package com.ruoyi.web;

import com.ruoyi.common.annotation.Anonymous;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.service.ModelTestTaskService;
import com.ruoyi.web.request.CarReviewTaskViewRequest;
import com.ruoyi.web.response.ModelTestTaskViewResponse;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 车型试验任务Controller
 * @author gxk
 */
@Api(tags = "车型试验子任务")
@RestController
@RequestMapping("/car/test/task")
public class ModelTestTaskController extends BaseController {

    @Autowired
    private ModelTestTaskService modelTestTaskService;

    /**
     * 查看车型试验任务详情
     * @param request
     * @return
     */
    @Anonymous
    @ApiOperation("查看车型试验任务详情")
    @PostMapping("/getById")
    public R<List<ModelTestTaskViewResponse>> view(@Validated @RequestBody CarReviewTaskViewRequest request) {
        List<ModelTestTaskViewResponse> modelTestTaskList = modelTestTaskService.viewModelTestTask(request.getTaskId());
        return R.ok(modelTestTaskList);
    }

    /**
     * 开始车型试验任务
     * @param request
     * @return
     */
    @Anonymous
    @ApiOperation("开始车型试验任务")
    @PostMapping("/start")
    public R<String> startReview(@Validated @RequestBody CarReviewTaskViewRequest request) {
        modelTestTaskService.startModelTestTask(request.getTaskId());
        return R.ok();
    }

}
